/* Do not remove or modify this comment!  It is required for file identification!
DNL
platform:/resource/HealthcareTutorial/src/Models/dnl/EFForTime.dnl
-263912112
 Do not remove or modify this comment!  It is required for file identification! */
package Models.java;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import java.io.File;
import java.io.Serializable;

import java.net.URI;
import java.net.URISyntaxException;

import java.util.ArrayList;

//import com.ms4systems.devs.analytics.PMF;
import java.util.TreeSet;

// Custom library code
//ID:LIB:0
import com.ms4systems.devs.analytics.*;
import com.ms4systems.devs.core.message.Message;
import com.ms4systems.devs.core.message.MessageBag;
import com.ms4systems.devs.core.message.Port;
import com.ms4systems.devs.core.message.impl.MessageBagImpl;
import com.ms4systems.devs.core.model.impl.AtomicModelImpl;
import com.ms4systems.devs.core.simulation.Simulation;
import com.ms4systems.devs.core.simulation.Simulator;
import com.ms4systems.devs.extensions.PhaseBased;
import com.ms4systems.devs.extensions.StateVariableBased;
import com.ms4systems.devs.helpers.impl.SimulationOptionsImpl;
import com.ms4systems.devs.simviewer.standalone.SimViewer;

//ENDID
// End custom library code
@SuppressWarnings("unused")
public class EFForTime extends AtomicModelImpl implements PhaseBased,
    StateVariableBased {
    private static final long serialVersionUID = 1L;

    //ID:SVAR:0
    private static final int ID_DELTAT = 0;

    //ENDID
    //ID:SVAR:1
    private static final int ID_TIMEPDF = 1;

    //ENDID
    //ID:SVAR:2
    private static final int ID_NUMTIMES = 2;

    // Declare state variables
    private PropertyChangeSupport propertyChangeSupport =
        new PropertyChangeSupport(this);
    protected double deltaT = 1;
    protected PMFForSurvival[] TimePDF = new PMFForSurvival[10];
    protected double NumTimes = 2;

    //ENDID
    String phase = "active";
    String previousPhase = null;
    Double sigma = 100.;
    Double previousSigma = Double.NaN;

    // End state variables

    // Input ports
    //ID:INP:0
    public final Port<Double> inLifeTime =
        addInputPort("inLifeTime", Double.class);

    //ENDID
    //ID:INP:1
    public final Port<Double> inVerySickTime =
        addInputPort("inVerySickTime", Double.class);

    //ENDID
    // End input ports

    // Output ports
    // End output ports
    protected SimulationOptionsImpl options = new SimulationOptionsImpl();
    protected double currentTime;

    // This variable is just here so we can use @SuppressWarnings("unused")
    private final int unusedIntVariableForWarnings = 0;

    public EFForTime() {
        this("EFForTime");
    }

    public EFForTime(String name) {
        this(name, null);
    }

    public EFForTime(String name, Simulator simulator) {
        super(name, simulator);
    }

    public void initialize() {
        super.initialize();

        currentTime = 0;

        // Default state variable initialization
        deltaT = 1;
        TimePDF = new PMFForSurvival[10];
        NumTimes = 2;

        holdIn("active", 100.);

        // Initialize Variables
        //ID:INIT
        defineTimePDF(1, "LifeTime");
        defineTimePDF(2, "VerySickTime");

        //defineTimePDF(3,"TimeToBurnoutDetection");
        //defineTimePDF(4,"TimeToOOI");
        //defineTimePDF(5,"TimeToEngage");
        //
        //defineTimePDF(6,"SBIRSuccess");
        //defineTimePDF(7,"TPYSuccess");
        //defineTimePDF(8,"InterceptionSuccess");

        //ENDID
        // End initialize variables
    }

    @Override
    public void internalTransition() {
        currentTime += sigma;

        if (phaseIs("active")) {
            getSimulator().modelMessage("Internal transition from active");

            //ID:TRA:active
            passivateIn("passive");

            //ENDID
            // Internal event code
            //ID:INT:active
            for (int i = 1; i <= NumTimes; i++) {
                computeHistogram(i);
            }

            //ENDID
            // End internal event code
            return;
        }

        //passivate();
    }

    @Override
    public void externalTransition(double timeElapsed, MessageBag input) {
        currentTime += timeElapsed;
        // Subtract time remaining until next internal transition (no effect if sigma == Infinity)
        sigma -= timeElapsed;

        // Store prior data
        previousPhase = phase;
        previousSigma = sigma;

        // Fire state transition functions
        if (phaseIs("active")) {
            // Fire state specific external transition functions

            //ID:EXT:active:
            fillTimeDoublePDF(input);

            //fillTimeBooleanPDF(input);

            //ENDID
        }
    }

    @Override
    public void confluentTransition(MessageBag input) {
        // confluentTransition with internalTransition first (by default)
        internalTransition();
        externalTransition(0, input);
    }

    @Override
    public Double getTimeAdvance() {
        return sigma;
    }

    @Override
    public MessageBag getOutput() {
        MessageBag output = new MessageBagImpl();

        return output;
    }

    // Custom function definitions

    //ID:CUST:0
    public void defineTimePDF(int i, String nm) {
        TimePDF[i] = new PMFForSurvival(deltaT);
        TimePDF[i].setName(nm);
    }

    public void fillTimeDoublePDF(MessageBag input) {
        for (int i = 1; i <= NumTimes; i++) {
            String nm = TimePDF[i].getName();
            Port<Double> port = (Port<Double>) getInputPort("in" + nm);

            ArrayList<Message<Double>> messageList = port.getMessages(input);
            for (int j = 0; j < messageList.size(); j++) {
                fillTimePDF(i, messageList.get(j).getData());
            }
        }
    }

    public void fillTimeBooleanPDF(MessageBag input) {
        for (int i = 6; i <= 8; i++) {
            String nm = TimePDF[i].getName();
            Port<Boolean> port = (Port<Boolean>) getInputPort("in" + nm);
            ArrayList<Message<Boolean>> messageList = port.getMessages(input);
            for (int j = 0; j < messageList.size(); j++) {
                fillTimePDF(i, messageList.get(j).getData());
            }
        }
    }

    public void fillTimePDF(int i, double t) {
        TimePDF[i].putBinSample(deltaT, t);
    }

    public void fillTimePDF(int i, boolean b) {
        double t = 1;
        if (b) {
            t = 2;
        }
        TimePDF[i].putBinSample(deltaT, t);
    }

    public void computeHistogram(int i) {
        PMF Histogram = TimePDF[i].makeProbabilityDistFromHistogram(deltaT);
        Histogram.setName(TimePDF[i].getName() + "Histogram");
        Histogram.drawLineChart();
        double avg = Histogram.getMean();
        double Std = Histogram.getStd();
        System.out.println(TimePDF[i].getName() + " " + avg + " " + Std);
    }

    //ENDID

    // End custom function definitions
    public static void main(String[] args) {
        SimulationOptionsImpl options = new SimulationOptionsImpl(args, true);

        // Uncomment the following line to disable SimViewer for this model
        // options.setDisableViewer(true);

        // Uncomment the following line to disable plotting for this model
        // options.setDisablePlotting(true);
        EFForTime model = new EFForTime();
        model.options = options;

        if (options.isDisableViewer()) { // Command line output only
            Simulation sim =
                new com.ms4systems.devs.core.simulation.impl.SimulationImpl("EFForTime Simulation",
                    model, options);
            sim.startSimulation(0);
            sim.simulateIterations(Long.MAX_VALUE);
        } else { // Use SimViewer
            SimViewer viewer = new SimViewer();
            viewer.open(model, options);
        }
    }

    public void addPropertyChangeListener(String propertyName,
        PropertyChangeListener listener) {
        propertyChangeSupport.addPropertyChangeListener(propertyName, listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        propertyChangeSupport.removePropertyChangeListener(listener);
    }

    // Getter/setter for deltaT
    public void setDeltaT(double deltaT) {
        propertyChangeSupport.firePropertyChange("deltaT", this.deltaT,
            this.deltaT = deltaT);
    }

    public double getDeltaT() {
        return this.deltaT;
    }

    // End getter/setter for deltaT

    // Getter/setter for TimePDF
    public void setTimePDF(PMFForSurvival[] TimePDF) {
        propertyChangeSupport.firePropertyChange("TimePDF", this.TimePDF,
            this.TimePDF = TimePDF);
    }

    public PMFForSurvival[] getTimePDF() {
        return this.TimePDF;
    }

    // End getter/setter for TimePDF

    // Getter/setter for NumTimes
    public void setNumTimes(double NumTimes) {
        propertyChangeSupport.firePropertyChange("NumTimes", this.NumTimes,
            this.NumTimes = NumTimes);
    }

    public double getNumTimes() {
        return this.NumTimes;
    }

    // End getter/setter for NumTimes

    // State variables
    public String[] getStateVariableNames() {
        return new String[] { "deltaT", "TimePDF", "NumTimes" };
    }

    public Object[] getStateVariableValues() {
        return new Object[] { deltaT, TimePDF, NumTimes };
    }

    public Class<?>[] getStateVariableTypes() {
        return new Class<?>[] { Double.class, PMFForSurvival[].class, Double.class };
    }

    public void setStateVariableValue(int index, Object value) {
        switch (index) {

            case ID_DELTAT:
                setDeltaT((Double) value);
                return;

            case ID_TIMEPDF:
                setTimePDF((PMFForSurvival[]) value);
                return;

            case ID_NUMTIMES:
                setNumTimes((Double) value);
                return;

            default:
                return;
        }
    }

    // Convenience functions
    protected void passivate() {
        passivateIn("passive");
    }

    protected void passivateIn(String phase) {
        holdIn(phase, Double.POSITIVE_INFINITY);
    }

    protected void holdIn(String phase, Double sigma) {
        this.phase = phase;
        this.sigma = sigma;
        getSimulator()
            .modelMessage("Holding in phase " + phase + " for time " + sigma);
    }

    protected static File getModelsDirectory() {
        URI dirUri;
        File dir;
        try {
            dirUri = EFForTime.class.getResource(".").toURI();
            dir = new File(dirUri);
        } catch (URISyntaxException e) {
            e.printStackTrace();
            throw new RuntimeException(
                "Could not find Models directory. Invalid model URL: " +
                EFForTime.class.getResource(".").toString());
        }
        boolean foundModels = false;
        while (dir != null && dir.getParentFile() != null) {
            if (dir.getName().equalsIgnoreCase("java") &&
                  dir.getParentFile().getName().equalsIgnoreCase("models")) {
                return dir.getParentFile();
            }
            dir = dir.getParentFile();
        }
        throw new RuntimeException(
            "Could not find Models directory from model path: " +
            dirUri.toASCIIString());
    }

    protected static File getDataFile(String fileName) {
        return getDataFile(fileName, "txt");
    }

    protected static File getDataFile(String fileName, String directoryName) {
        File modelDir = getModelsDirectory();
        File dir = new File(modelDir, directoryName);
        if (dir == null) {
            throw new RuntimeException("Could not find '" + directoryName +
                "' directory from model path: " + modelDir.getAbsolutePath());
        }
        File dataFile = new File(dir, fileName);
        if (dataFile == null) {
            throw new RuntimeException("Could not find '" + fileName +
                "' file in directory: " + dir.getAbsolutePath());
        }
        return dataFile;
    }

    protected void msg(String msg) {
        getSimulator().modelMessage(msg);
    }

    // Phase display
    public boolean phaseIs(String phase) {
        return this.phase.equals(phase);
    }

    public String getPhase() {
        return phase;
    }

    public String[] getPhaseNames() {
        return new String[] { "active", "passive" };
    }
}
