/* Do not remove or modify this comment!  It is required for file identification!
DNL
platform:/resource/HealthcareTutorial/src/Models/dnl/SickPatientCTM.dnl
1175622648
 Do not remove or modify this comment!  It is required for file identification! */
package Models.java;

import org.eclipse.swt.widgets.Display;

import org.jfree.data.general.Dataset;
import org.jfree.data.general.DatasetGroup;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import java.io.File;
import java.io.Serializable;

import java.net.URI;
import java.net.URISyntaxException;

import java.util.ArrayList;
import java.util.List;

import com.ms4systems.devs.core.message.Message;
import com.ms4systems.devs.core.message.MessageBag;
import com.ms4systems.devs.core.message.Port;
import com.ms4systems.devs.core.message.impl.MessageBagImpl;
import com.ms4systems.devs.core.model.impl.AtomicModelImpl;
import com.ms4systems.devs.core.simulation.Simulation;
import com.ms4systems.devs.core.simulation.Simulator;
import com.ms4systems.devs.extensions.PhaseBased;
import com.ms4systems.devs.extensions.StateVariableBased;
import com.ms4systems.devs.extensions.chart.Plottable;
import com.ms4systems.devs.helpers.impl.SimulationOptionsImpl;

// Custom library code
//ID:LIB:0
//<CTM>
import com.ms4systems.devs.markov.*;
import com.ms4systems.devs.simviewer.standalone.SimViewer;

//<CTM>

//ENDID
// End custom library code
@SuppressWarnings("unused")
public class SickPatientCTM extends AtomicModelImpl implements PhaseBased,
    StateVariableBased, Plottable {
    private static final long serialVersionUID = 1L;

    //ID:SVAR:0
    private static final int ID_MAXTA = 0;

    //ENDID
    //ID:SVAR:1
    private static final int ID_CTM = 1;

    //ENDID
    //ID:SVAR:2
    private static final int ID_PROBOFDEAD = 2;

    //ENDID
    //ID:SVAR:3
    private static final int ID_ELAPSEDTIMEOFDEAD = 3;

    //ENDID
    //ID:SVAR:4
    private static final int ID_PROBOFHEALTHY = 4;

    //ENDID
    //ID:SVAR:5
    private static final int ID_ELAPSEDTIMEOFHEALTHY = 5;

    //ENDID
    //ID:SVAR:6
    private static final int ID_PROBOFSICK = 6;

    //ENDID
    //ID:SVAR:7
    private static final int ID_ELAPSEDTIMEOFSICK = 7;

    //ENDID
    //ID:SVAR:8
    private static final int ID_PROBOFVERYSICK = 8;

    //ENDID
    //ID:SVAR:9
    private static final int ID_ELAPSEDTIMEOFVERYSICK = 9;

    // Declare state variables
    private PropertyChangeSupport propertyChangeSupport =
        new PropertyChangeSupport(this);
    protected double maxTA = Double.MAX_VALUE;
    protected ContinuousTimeMarkov ctm = new ContinuousTimeMarkov();
    protected double ProbOfDead;
    protected double ElapsedTimeOfDead;
    protected double ProbOfHealthy;
    protected double ElapsedTimeOfHealthy;
    protected double ProbOfSick;
    protected double ElapsedTimeOfSick;
    protected double ProbOfVerySick;
    protected double ElapsedTimeOfVerySick;

    //ENDID
    String phase = "Healthy";
    String previousPhase = null;
    Double sigma = maxTA;
    Double previousSigma = Double.NaN;

    // End state variables

    // Input ports
    // End input ports

    // Output ports
    //ID:OUTP:0
    public final Port<Double> outVerySickTime =
        addOutputPort("outVerySickTime", Double.class);

    //ENDID
    //ID:OUTP:1
    public final Port<Double> outLifeTime =
        addOutputPort("outLifeTime", Double.class);

    //ENDID
    // End output ports

    // Graph data holders
    protected XYSeries series0;
    protected SimulationOptionsImpl options = new SimulationOptionsImpl();
    protected double currentTime;

    // This variable is just here so we can use @SuppressWarnings("unused")
    private final int unusedIntVariableForWarnings = 0;

    public SickPatientCTM() {
        this("SickPatientCTM");
    }

    public SickPatientCTM(String name) {
        this(name, null);
    }

    public SickPatientCTM(String name, Simulator simulator) {
        super(name, simulator);
    }

    public void initialize() {
        super.initialize();

        currentTime = 0;

        // Default state variable initialization
        maxTA = Double.MAX_VALUE;
        ctm = new ContinuousTimeMarkov();

        holdIn("Healthy", maxTA);

        // Initialize Variables
        //ID:INIT
        //<CTM>
        ctm = new ContinuousTimeMarkov();
        ctm.setTimeToNextEvent(0.0);
        ctm.setOutput(false);
        String path = getModelsDirectory().getAbsolutePath();
        path.replace("bin", "src");
        try {
            ctm.fillTransitionInfoList(path + File.separator + "xml" +
                File.separator + "SickPatientCTM.xml");
        } catch (Exception e) {
            e.printStackTrace();
        }
        holdIn("Healthy", 0.);

        //<CTM>
        TransitionInfo ti = ctm.getTransitionInfoFor("Sick", "VerySick");
        if (getName().contains("Susceptible")) {
            ti.setProbValue(.6);
        } else if (getName().contains("VerySusceptible")) {
            ti.setProbValue(.9);
        } else if (getName().contains("Immune")) {
            ti.setProbValue(.1);
        }

        //ENDID
        // End initialize variables
        updateGraphValues(); // Graph support code

    }

    @Override
    public void internalTransition() {
        currentTime += sigma;

        if (phaseIs("Healthy")) {
            getSimulator().modelMessage("Internal transition from Healthy");

            //ID:TRA:Healthy
            holdIn("Dead", maxTA);
            //ENDID
            // Internal event code
            //ID:INT:Healthy
            /*<dnl>
            <ProbDEVS>
            <TransitionInfo>
            <StartState>Healthy</StartState>
            <EndState>Dead</EndState>
            <ProbValue>0.1</ProbValue>
            </TransitionInfo>
            <TransitionInfo>
            <StartState>Healthy</StartState>
            <EndState>Sick</EndState>
            <ProbValue>0.3</ProbValue>
            </TransitionInfo>
            </ProbDEVS>
            <dnl>*/

            //<CTM>
            internalTransitionForMarkov("Healthy", maxTA, "");
            //<CTM>
            //ENDID
            // End internal event code
            updateGraphValues(); // Graph support code
            return;
        }
        if (phaseIs("Dead")) {
            getSimulator().modelMessage("Internal transition from Dead");

            //ID:TRA:Dead
            holdIn("Dead", maxTA);
            //ENDID
            // Internal event code
            //ID:INT:Dead
            /*<dnl>
            <ProbDEVS>
            <TransitionInfo>
            <StartState>Dead</StartState>
            <EndState>Dead</EndState>
            <ProbValue>1.0</ProbValue>
            </TransitionInfo>
            </ProbDEVS>
            <dnl>*/

            //<CTM>
            internalTransitionForMarkov("Dead", maxTA, "");
            //<CTM>
            //ENDID
            // End internal event code
            updateGraphValues(); // Graph support code
            return;
        }
        if (phaseIs("Sick")) {
            getSimulator().modelMessage("Internal transition from Sick");

            //ID:TRA:Sick
            holdIn("VerySick", maxTA);
            //ENDID
            // Internal event code
            //ID:INT:Sick
            /*<dnl>
            <ProbDEVS>
            <TransitionInfo>
            <StartState>Sick</StartState>
            <EndState>Healthy</EndState>
            <ProbValue>0.6</ProbValue>
            </TransitionInfo>
            <TransitionInfo>
            <StartState>Sick</StartState>
            <EndState>Dead</EndState>
            <ProbValue>0.1</ProbValue>
            </TransitionInfo>
            <TransitionInfo>
            <StartState>Sick</StartState>
            <EndState>VerySick</EndState>
            <ProbValue>0.2</ProbValue>
            </TransitionInfo>
            </ProbDEVS>
            <dnl>*/

            //<CTM>
            internalTransitionForMarkov("Sick", maxTA, "");
            //<CTM>
            //ENDID
            // End internal event code
            updateGraphValues(); // Graph support code
            return;
        }
        if (phaseIs("VerySick")) {
            getSimulator().modelMessage("Internal transition from VerySick");

            //ID:TRA:VerySick
            holdIn("Dead", maxTA);
            //ENDID
            // Internal event code
            //ID:INT:VerySick
            /*<dnl>
            <ProbDEVS>
            <TransitionInfo>
            <StartState>VerySick</StartState>
            <EndState>Dead</EndState>
            <ProbValue>0.3</ProbValue>
            </TransitionInfo>
            <TransitionInfo>
            <StartState>VerySick</StartState>
            <EndState>Sick</EndState>
            <ProbValue>0.4</ProbValue>
            </TransitionInfo>
            </ProbDEVS>
            <InternalTransitionInfo>
            <InternalTransition>
            <StartState>VerySick</StartState>
            <EndState>Dead</EndState>
            <Type>3</Type>
            <Name></Name>
            </InternalTransition>
            <InternalTransition>
            <StartState>VerySick</StartState>
            <EndState>Sick</EndState>
            <Type>3</Type>
            <Name></Name>
            </InternalTransition>
            <InternalTransition>
            <StartState>VerySick</StartState>
            <EndState>Sick</EndState>
            <Type>1</Type>
            <Name>VerySickTime</Name>
            </InternalTransition>
            </InternalTransitionInfo>
            <dnl>*/

            //<CTM>
            internalTransitionForMarkov("VerySick", maxTA, "Sick");
            //<CTM>
            //ENDID
            // End internal event code
            updateGraphValues(); // Graph support code
            return;
        }

        updateGraphValues(); // Graph support code

        //passivate();
    }

    @Override
    public void externalTransition(double timeElapsed, MessageBag input) {
        currentTime += timeElapsed;
        // Subtract time remaining until next internal transition (no effect if sigma == Infinity)
        sigma -= timeElapsed;

        // Store prior data
        previousPhase = phase;
        previousSigma = sigma;

        // Fire state transition functions
        updateGraphValues(); // Graph support code

    }

    @Override
    public void confluentTransition(MessageBag input) {
        // confluentTransition with internalTransition first (by default)
        internalTransition();
        externalTransition(0, input);
    }

    @Override
    public Double getTimeAdvance() {
        return sigma;
    }

    @Override
    public MessageBag getOutput() {
        MessageBag output = new MessageBagImpl();

        if (phaseIs("VerySick")) {

            // Output event code
            //ID:OUT:VerySick

            //<CTM>
            if (ctm.isOutput() && ctm.getNextState().equals("Sick")) {

                //replace output by your own code
                //	output.add(outVerySickTime, ProbOfVerySick);
            }

            //<CTM>
            if (ctm.isOutput() && ctm.getNextState().equals("Sick")) {
                output.add(outVerySickTime, ProbOfVerySick);
            }

            if (ctm.isOutput() && ctm.getNextState().equals("Dead")) {
                output.add(outVerySickTime, 100 * ProbOfVerySick);
                output.add(outLifeTime, currentTime);
            }

            //ENDID
            // End output event code
        }
        return output;
    }

    // Custom function definitions

    //ID:CUST:0
    //<CTM>
    public double[] fillProbabilities(String state) {
        if (ctm.getSuccs(state).size() == 0) {
            return new double[0];
        }
        double[] probabilities = new double[ctm.getSuccs(state).size()];
        for (String succ : ctm.getSuccs(state)) {
            if (succ.equals(state)) {
                continue;
            }
            com.ms4systems.devs.markov.TransitionInfo ti =
                ctm.getTransitionInfoFor(state, succ);
            probabilities[ctm.getIndex(succ)] = ti.getProbValue();
        }
        return probabilities;
    }

    public void internalTransitionForMarkov(String state, double sta,
        String phase, double[] probabilities) {
        double timeToNextEvent = ctm.getTimeToNextEvent();
        if (timeToNextEvent == 0) {
            timeToNextEvent = Double.POSITIVE_INFINITY;
            int i = 0;
            if (ctm.getSuccs(state).size() == 0) {
                return;
            }
            for (String succ : ctm.getSuccs(state)) {
                if (succ.equals(state)) {
                    continue;
                }
                double prob = probabilities[ctm.getIndex(succ)];
                double time = ctm.timeToNextEvent(prob);
                if (time < timeToNextEvent) {
                    ctm.setTimeToNextEvent(time);
                    timeToNextEvent = time;
                    ctm.setNextState(succ);
                }
                i++;
            }
            if (timeToNextEvent > sta) {
                timeToNextEvent = sta;
                ctm.setTimeToNextEvent(timeToNextEvent);
                if (!phase.equals("")) {
                    ctm.setNextState(phase);
                } else {
                    //ctm.setNextState(ctm.getSuccs(state).get(0));
                    ctm.setNextState(state);
                }
            }
        }
        if (previousPhase != null && previousPhase.equals(state)) {
            previousPhase = null;
            ctm.setTimeToNextEvent(0.0);
            String nextState = ctm.getNextState();
            holdIn(nextState, 0.);
            ctm.setOutput(false);
            generateGraphData();
        } else {
            com.ms4systems.devs.markov.TimeInState tm =
                ctm.getTimeInState(state);
            if (tm == null) {
                tm = new com.ms4systems.devs.markov.TimeInState();
                tm.setStateName(state);
                tm.setCountInState(0);
                tm.setElapsedTime(0.);
                ctm.getTimeInStateList().add(tm);
            }
            holdIn(state, timeToNextEvent);
            ctm.setOutput(true);
            previousPhase = state;
            ctm.incCount(tm);
            ctm.updateElapsedTime(tm, timeToNextEvent);
            double accLifeTime = ctm.getAccLifeTime() + timeToNextEvent;
            ctm.setAccLifeTime(accLifeTime);
            ctm.printTimeInState();
        }
    }

    public void internalTransitionForMarkov(String state, double sta,
        String phase) {
        double timeToNextEvent = ctm.getTimeToNextEvent();
        if (timeToNextEvent == 0) {
            timeToNextEvent = Double.POSITIVE_INFINITY;
            int i = 0;
            if (ctm.getSuccs(state).size() == 0) {
                return;
            }
            for (String succ : ctm.getSuccs(state)) {
                if (succ.equals(state)) {
                    continue;
                }
                com.ms4systems.devs.markov.TransitionInfo ti =
                    ctm.getTransitionInfoFor(state, succ);
                double prob = ti.getProbValue();
                double time = ctm.timeToNextEvent(prob);
                if (time < timeToNextEvent) {
                    ctm.setTimeToNextEvent(time);
                    timeToNextEvent = time;
                    ctm.setNextState(succ);
                }
                i++;
            }
            if (timeToNextEvent > sta) {
                timeToNextEvent = sta;
                ctm.setTimeToNextEvent(timeToNextEvent);
                if (!phase.equals("")) {
                    ctm.setNextState(phase);
                } else {
                    //ctm.setNextState(ctm.getSuccs(state).get(0));
                    ctm.setNextState(state);
                }
            }
        }
        if (previousPhase != null && previousPhase.equals(state)) {
            previousPhase = null;
            ctm.setTimeToNextEvent(0.0);
            String nextState = ctm.getNextState();
            holdIn(nextState, 0.);
            ctm.setOutput(false);
            generateGraphData();
        } else {
            com.ms4systems.devs.markov.TimeInState tm =
                ctm.getTimeInState(state);
            if (tm == null) {
                tm = new com.ms4systems.devs.markov.TimeInState();
                tm.setStateName(state);
                tm.setCountInState(0);
                tm.setElapsedTime(0.);
                ctm.getTimeInStateList().add(tm);
            }
            holdIn(state, timeToNextEvent);
            ctm.setOutput(true);
            previousPhase = state;
            ctm.incCount(tm);
            ctm.updateElapsedTime(tm, timeToNextEvent);
            double accLifeTime = ctm.getAccLifeTime() + timeToNextEvent;
            ctm.setAccLifeTime(accLifeTime);
            ctm.printTimeInState();
        }
    }

    public void generateGraphData() {
        double totalTime = ctm.getAccLifeTime();
        com.ms4systems.devs.markov.TimeInState timeDead =
            ctm.getTimeInState("Dead");
        if (timeDead != null) {
            double elapsedTime = timeDead.getElapsedTime();
            ProbOfDead = elapsedTime / totalTime;
            ElapsedTimeOfDead = elapsedTime;
        } else {
            ProbOfDead = 0.0;
            ElapsedTimeOfDead = 0.0;
        }

        com.ms4systems.devs.markov.TimeInState timeHealthy =
            ctm.getTimeInState("Healthy");
        if (timeHealthy != null) {
            double elapsedTime = timeHealthy.getElapsedTime();
            ProbOfHealthy = elapsedTime / totalTime;
            ElapsedTimeOfHealthy = elapsedTime;
        } else {
            ProbOfHealthy = 0.0;
            ElapsedTimeOfHealthy = 0.0;
        }

        com.ms4systems.devs.markov.TimeInState timeSick =
            ctm.getTimeInState("Sick");
        if (timeSick != null) {
            double elapsedTime = timeSick.getElapsedTime();
            ProbOfSick = elapsedTime / totalTime;
            ElapsedTimeOfSick = elapsedTime;
        } else {
            ProbOfSick = 0.0;
            ElapsedTimeOfSick = 0.0;
        }

        com.ms4systems.devs.markov.TimeInState timeVerySick =
            ctm.getTimeInState("VerySick");
        if (timeVerySick != null) {
            double elapsedTime = timeVerySick.getElapsedTime();
            ProbOfVerySick = elapsedTime / totalTime;
            ElapsedTimeOfVerySick = elapsedTime;
        } else {
            ProbOfVerySick = 0.0;
            ElapsedTimeOfVerySick = 0.0;
        }
    }

    //<CTM>

    //ENDID

    // End custom function definitions
    public static void main(String[] args) {
        SimulationOptionsImpl options = new SimulationOptionsImpl(args, true);

        // Uncomment the following line to disable SimViewer for this model
        // options.setDisableViewer(true);

        // Uncomment the following line to disable plotting for this model
        // options.setDisablePlotting(true);
        SickPatientCTM model = new SickPatientCTM();
        model.options = options;

        if (options.isDisableViewer()) { // Command line output only
            Simulation sim =
                new com.ms4systems.devs.core.simulation.impl.SimulationImpl("SickPatientCTM Simulation",
                    model, options);
            sim.startSimulation(0);
            sim.simulateIterations(Long.MAX_VALUE);
        } else { // Use SimViewer
            SimViewer viewer = new SimViewer();
            viewer.open(model, options);
        }
    }

    public void addPropertyChangeListener(String propertyName,
        PropertyChangeListener listener) {
        propertyChangeSupport.addPropertyChangeListener(propertyName, listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        propertyChangeSupport.removePropertyChangeListener(listener);
    }

    // Getter/setter for maxTA
    public void setMaxTA(double maxTA) {
        propertyChangeSupport.firePropertyChange("maxTA", this.maxTA,
            this.maxTA = maxTA);
    }

    public double getMaxTA() {
        return this.maxTA;
    }

    // End getter/setter for maxTA

    // Getter/setter for ctm
    public void setCtm(ContinuousTimeMarkov ctm) {
        propertyChangeSupport.firePropertyChange("ctm", this.ctm, this.ctm = ctm);
    }

    public ContinuousTimeMarkov getCtm() {
        return this.ctm;
    }

    // End getter/setter for ctm

    // Getter/setter for ProbOfDead
    public void setProbOfDead(double ProbOfDead) {
        propertyChangeSupport.firePropertyChange("ProbOfDead", this.ProbOfDead,
            this.ProbOfDead = ProbOfDead);
    }

    public double getProbOfDead() {
        return this.ProbOfDead;
    }

    // End getter/setter for ProbOfDead

    // Getter/setter for ElapsedTimeOfDead
    public void setElapsedTimeOfDead(double ElapsedTimeOfDead) {
        propertyChangeSupport.firePropertyChange("ElapsedTimeOfDead",
            this.ElapsedTimeOfDead, this.ElapsedTimeOfDead = ElapsedTimeOfDead);
    }

    public double getElapsedTimeOfDead() {
        return this.ElapsedTimeOfDead;
    }

    // End getter/setter for ElapsedTimeOfDead

    // Getter/setter for ProbOfHealthy
    public void setProbOfHealthy(double ProbOfHealthy) {
        propertyChangeSupport.firePropertyChange("ProbOfHealthy",
            this.ProbOfHealthy, this.ProbOfHealthy = ProbOfHealthy);
    }

    public double getProbOfHealthy() {
        return this.ProbOfHealthy;
    }

    // End getter/setter for ProbOfHealthy

    // Getter/setter for ElapsedTimeOfHealthy
    public void setElapsedTimeOfHealthy(double ElapsedTimeOfHealthy) {
        propertyChangeSupport.firePropertyChange("ElapsedTimeOfHealthy",
            this.ElapsedTimeOfHealthy,
            this.ElapsedTimeOfHealthy = ElapsedTimeOfHealthy);
    }

    public double getElapsedTimeOfHealthy() {
        return this.ElapsedTimeOfHealthy;
    }

    // End getter/setter for ElapsedTimeOfHealthy

    // Getter/setter for ProbOfSick
    public void setProbOfSick(double ProbOfSick) {
        propertyChangeSupport.firePropertyChange("ProbOfSick", this.ProbOfSick,
            this.ProbOfSick = ProbOfSick);
    }

    public double getProbOfSick() {
        return this.ProbOfSick;
    }

    // End getter/setter for ProbOfSick

    // Getter/setter for ElapsedTimeOfSick
    public void setElapsedTimeOfSick(double ElapsedTimeOfSick) {
        propertyChangeSupport.firePropertyChange("ElapsedTimeOfSick",
            this.ElapsedTimeOfSick, this.ElapsedTimeOfSick = ElapsedTimeOfSick);
    }

    public double getElapsedTimeOfSick() {
        return this.ElapsedTimeOfSick;
    }

    // End getter/setter for ElapsedTimeOfSick

    // Getter/setter for ProbOfVerySick
    public void setProbOfVerySick(double ProbOfVerySick) {
        propertyChangeSupport.firePropertyChange("ProbOfVerySick",
            this.ProbOfVerySick, this.ProbOfVerySick = ProbOfVerySick);
    }

    public double getProbOfVerySick() {
        return this.ProbOfVerySick;
    }

    // End getter/setter for ProbOfVerySick

    // Getter/setter for ElapsedTimeOfVerySick
    public void setElapsedTimeOfVerySick(double ElapsedTimeOfVerySick) {
        propertyChangeSupport.firePropertyChange("ElapsedTimeOfVerySick",
            this.ElapsedTimeOfVerySick,
            this.ElapsedTimeOfVerySick = ElapsedTimeOfVerySick);
    }

    public double getElapsedTimeOfVerySick() {
        return this.ElapsedTimeOfVerySick;
    }

    // End getter/setter for ElapsedTimeOfVerySick

    // State variables
    public String[] getStateVariableNames() {
        return new String[] {
            "maxTA", "ctm", "ProbOfDead", "ElapsedTimeOfDead", "ProbOfHealthy",
            "ElapsedTimeOfHealthy", "ProbOfSick", "ElapsedTimeOfSick",
            "ProbOfVerySick", "ElapsedTimeOfVerySick"
        };
    }

    public Object[] getStateVariableValues() {
        return new Object[] {
            maxTA, ctm, ProbOfDead, ElapsedTimeOfDead, ProbOfHealthy,
            ElapsedTimeOfHealthy, ProbOfSick, ElapsedTimeOfSick, ProbOfVerySick,
            ElapsedTimeOfVerySick
        };
    }

    public Class<?>[] getStateVariableTypes() {
        return new Class<?>[] {
            Double.class, ContinuousTimeMarkov.class, Double.class, Double.class,
            Double.class, Double.class, Double.class, Double.class, Double.class,
            Double.class
        };
    }

    public void setStateVariableValue(int index, Object value) {
        switch (index) {

            case ID_MAXTA:
                setMaxTA((Double) value);
                return;

            case ID_CTM:
                setCtm((ContinuousTimeMarkov) value);
                return;

            case ID_PROBOFDEAD:
                setProbOfDead((Double) value);
                return;

            case ID_ELAPSEDTIMEOFDEAD:
                setElapsedTimeOfDead((Double) value);
                return;

            case ID_PROBOFHEALTHY:
                setProbOfHealthy((Double) value);
                return;

            case ID_ELAPSEDTIMEOFHEALTHY:
                setElapsedTimeOfHealthy((Double) value);
                return;

            case ID_PROBOFSICK:
                setProbOfSick((Double) value);
                return;

            case ID_ELAPSEDTIMEOFSICK:
                setElapsedTimeOfSick((Double) value);
                return;

            case ID_PROBOFVERYSICK:
                setProbOfVerySick((Double) value);
                return;

            case ID_ELAPSEDTIMEOFVERYSICK:
                setElapsedTimeOfVerySick((Double) value);
                return;

            default:
                return;
        }
    }

    // Convenience functions
    protected void passivate() {
        passivateIn("passive");
    }

    protected void passivateIn(String phase) {
        holdIn(phase, Double.POSITIVE_INFINITY);
    }

    protected void holdIn(String phase, Double sigma) {
        this.phase = phase;
        this.sigma = sigma;
        getSimulator()
            .modelMessage("Holding in phase " + phase + " for time " + sigma);
    }

    protected static File getModelsDirectory() {
        URI dirUri;
        File dir;
        try {
            dirUri = SickPatientCTM.class.getResource(".").toURI();
            dir = new File(dirUri);
        } catch (URISyntaxException e) {
            e.printStackTrace();
            throw new RuntimeException(
                "Could not find Models directory. Invalid model URL: " +
                SickPatientCTM.class.getResource(".").toString());
        }
        boolean foundModels = false;
        while (dir != null && dir.getParentFile() != null) {
            if (dir.getName().equalsIgnoreCase("java") &&
                  dir.getParentFile().getName().equalsIgnoreCase("models")) {
                return dir.getParentFile();
            }
            dir = dir.getParentFile();
        }
        throw new RuntimeException(
            "Could not find Models directory from model path: " +
            dirUri.toASCIIString());
    }

    protected static File getDataFile(String fileName) {
        return getDataFile(fileName, "txt");
    }

    protected static File getDataFile(String fileName, String directoryName) {
        File modelDir = getModelsDirectory();
        File dir = new File(modelDir, directoryName);
        if (dir == null) {
            throw new RuntimeException("Could not find '" + directoryName +
                "' directory from model path: " + modelDir.getAbsolutePath());
        }
        File dataFile = new File(dir, fileName);
        if (dataFile == null) {
            throw new RuntimeException("Could not find '" + fileName +
                "' file in directory: " + dir.getAbsolutePath());
        }
        return dataFile;
    }

    protected void msg(String msg) {
        getSimulator().modelMessage(msg);
    }

    // Phase display
    public boolean phaseIs(String phase) {
        return this.phase.equals(phase);
    }

    public String getPhase() {
        return phase;
    }

    public String[] getPhaseNames() {
        return new String[] { "Healthy", "Dead", "Sick", "VerySick" };
    }

    // Graph support
    public List<Dataset> getPlotDatasets() {
        if (options.isDisablePlotting()) {
            return null;
        }
        ArrayList<Dataset> lst = new ArrayList<Dataset>(1);

        {
            XYSeriesCollection dataset = new XYSeriesCollection();
            dataset.setGroup(new DatasetGroup("Probabilites"));
            series0 = new XYSeries("ProbOfVerySick");
            dataset.addSeries(series0);
            lst.add((Dataset) dataset);
        }

        return lst;
    }

    // Graph update command
    protected void updateGraphValues() {
        if (options.isDisablePlotting()) {
            return;
        }
        Display.getDefault().asyncExec(new Runnable() {
                @Override
                public void run() {
                    series0.add(getSimulator().getCurrentTime(),
                        (double) ProbOfVerySick);
                }
            });
    }
}
