/* Do not remove or modify this comment!  It is required for file identification!
DNL
platform:/resource/HealthcareTutorial/src/Models/dnl/SickPatientNoDeathMM.dnl
-1690315895
 Do not remove or modify this comment!  It is required for file identification! */
package Models.java;

import org.eclipse.swt.widgets.Display;

import org.jfree.data.general.Dataset;
import org.jfree.data.general.DatasetGroup;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import java.io.File;
import java.io.Serializable;

import java.net.URI;
import java.net.URISyntaxException;

// Custom library code
//ID:LIB:0

//<MM>
import java.util.*;
import java.util.ArrayList;
import java.util.List;

import com.ms4systems.devs.core.message.Message;
import com.ms4systems.devs.core.message.MessageBag;
import com.ms4systems.devs.core.message.Port;
import com.ms4systems.devs.core.message.impl.MessageBagImpl;
import com.ms4systems.devs.core.model.impl.AtomicModelImpl;
import com.ms4systems.devs.core.simulation.Simulation;
import com.ms4systems.devs.core.simulation.Simulator;
import com.ms4systems.devs.extensions.PhaseBased;
import com.ms4systems.devs.extensions.StateVariableBased;
import com.ms4systems.devs.extensions.chart.Plottable;
import com.ms4systems.devs.helpers.impl.SimulationOptionsImpl;
import com.ms4systems.devs.markov.*;
import com.ms4systems.devs.markovmodel.MarkovMat;
import com.ms4systems.devs.simviewer.standalone.SimViewer;

//<MM>

//ENDID
// End custom library code
@SuppressWarnings("unused")
public class SickPatientNoDeathMM extends AtomicModelImpl implements PhaseBased,
    StateVariableBased, Plottable {
    private static final long serialVersionUID = 1L;

    //ID:SVAR:0
    private static final int ID_CTM = 0;

    //ENDID
    //ID:SVAR:1
    private static final int ID_FIRSTOUTPUT = 1;

    //ENDID
    //ID:SVAR:2
    private static final int ID_MAXIMA = 2;

    //ENDID
    //ID:SVAR:3
    private static final int ID_MM = 3;

    //ENDID
    //ID:SVAR:4
    private static final int ID_SERIES = 4;

    //ENDID
    //ID:SVAR:5
    private static final int ID_XMLFILENAME = 5;

    //ENDID
    //ID:SVAR:6
    private static final int ID_PROBOFHEALTHY = 6;

    //ENDID
    //ID:SVAR:7
    private static final int ID_PROBOFSICK = 7;

    //ENDID
    //ID:SVAR:8
    private static final int ID_PROBOFVERYSICK = 8;

    //ENDID
    //ID:SVAR:9
    private static final int ID_QUALITYOFHEALTH = 9;

    //ENDID
    //ID:SVAR:10
    private static final int ID_COSTOFTREATMENT = 10;

    //ENDID
    //ID:SVAR:11
    private static final int ID_POTENCYOFTREATMENT = 11;

    //ENDID
    //ID:SVAR:12
    private static final int ID_VALUEOFTREATMENT = 12;

    // Declare state variables
    private PropertyChangeSupport propertyChangeSupport =
        new PropertyChangeSupport(this);
    protected ContinuousTimeMarkov ctm = new ContinuousTimeMarkov();
    protected boolean[] firstOutput = new boolean[] {  };
    protected Double[] maxima = new Double[] {  };
    protected MarkovMat mm;
    protected XYSeries[] series;
    protected String xmlFileName = "SickPatientNoDeathCTM.xml";
    protected double ProbOfHealthy;
    protected double ProbOfSick;
    protected double ProbOfVerySick;
    protected double QualityOfHealth = 0;
    protected double CostOfTreatment = 0;
    protected double PotencyOfTreatment = .5;
    protected double ValueOfTreatment = 0;

    //ENDID
    String phase = "InternalTransition";
    String previousPhase = null;
    Double sigma = 1.0;
    Double previousSigma = Double.NaN;

    // End state variables

    // Input ports
    //ID:INP:0
    public final Port<Serializable> inPause =
        addInputPort("inPause", Serializable.class);

    //ENDID
    //ID:INP:1
    public final Port<Serializable> inGetInput =
        addInputPort("inGetInput", Serializable.class);

    //ENDID
    // End input ports

    // Output ports
    //ID:OUTP:0
    public final Port<Serializable> outProb =
        addOutputPort("outProb", Serializable.class);

    //ENDID
    // End output ports

    // Graph data holders
    protected XYSeries series0;
    protected XYSeries series1;
    protected XYSeries series2;
    protected XYSeries series3;
    protected XYSeries series4;
    protected XYSeries series5;
    protected XYSeries series6;
    protected SimulationOptionsImpl options = new SimulationOptionsImpl();
    protected double currentTime;

    // This variable is just here so we can use @SuppressWarnings("unused")
    private final int unusedIntVariableForWarnings = 0;

    public SickPatientNoDeathMM() {
        this("SickPatientNoDeathMM");
    }

    public SickPatientNoDeathMM(String name) {
        this(name, null);
    }

    public SickPatientNoDeathMM(String name, Simulator simulator) {
        super(name, simulator);
    }

    public void initialize() {
        super.initialize();

        currentTime = 0;

        // Default state variable initialization
        ctm = new ContinuousTimeMarkov();
        firstOutput = new boolean[] {  };
        maxima = new Double[] {  };
        xmlFileName = "SickPatientNoDeathCTM.xml";
        QualityOfHealth = 0;
        CostOfTreatment = 0;
        PotencyOfTreatment = .5;
        ValueOfTreatment = 0;

        holdIn("InternalTransition", 1.0);

        // Initialize Variables
        //ID:INIT
        //<MM>
        mm = makeMarkovMat();
        setInitialStateVector(mm, "Healthy");
        printStateVector(mm);
        mm.setLastStateVector(mm.getStateVector());
        updateStateVectorGraphValues();
        firstOutput = new boolean[mm.getStateVector().length]; //<MM>
                                                               //Column Names : 
                                                               //0 : Healthy, 1 : Sick, 2 : VerySick

        setColumn(mm, 2,
            new double[] { 0.0, PotencyOfTreatment, 1 - PotencyOfTreatment });
        mm.print();

        //ENDID
        // End initialize variables
        updateGraphValues(); // Graph support code

    }

    @Override
    public void internalTransition() {
        currentTime += sigma;

        if (phaseIs("InternalTransition")) {
            getSimulator()
                .modelMessage("Internal transition from InternalTransition");

            //ID:TRA:InternalTransition
            holdIn("InternalTransition", 1.0);
            //ENDID
            // Internal event code
            //ID:INT:InternalTransition
            //<MM>
            internalTransitionForMatrix();
            QualityOfHealth = ProbOfHealthy / (ProbOfSick + ProbOfVerySick);
            CostOfTreatment = PotencyOfTreatment * ProbOfVerySick;
            ValueOfTreatment = QualityOfHealth / CostOfTreatment;
            if (ValueOfTreatment > 100) {
                ValueOfTreatment = 100;
            }
            //<MM>

            //ENDID
            // End internal event code
            updateGraphValues(); // Graph support code
            return;
        }

        updateGraphValues(); // Graph support code

        //passivate();
    }

    @Override
    public void externalTransition(double timeElapsed, MessageBag input) {
        currentTime += timeElapsed;
        // Subtract time remaining until next internal transition (no effect if sigma == Infinity)
        sigma -= timeElapsed;

        // Store prior data
        previousPhase = phase;
        previousSigma = sigma;

        // Fire state transition functions
        if (phaseIs("InternalTransition")) {
            if (input.hasMessages(inPause)) {
                ArrayList<Message<Serializable>> messageList =
                    inPause.getMessages(input);

                passivateIn("Stop");

                updateGraphValues(); // Graph support code

                return;
            }
            if (input.hasMessages(inGetInput)) {
                ArrayList<Message<Serializable>> messageList =
                    inGetInput.getMessages(input);

                holdIn("InternalTransition", 1.0);

                updateGraphValues(); // Graph support code

                return;
            }
        }

        updateGraphValues(); // Graph support code

    }

    @Override
    public void confluentTransition(MessageBag input) {
        // confluentTransition with internalTransition first (by default)
        internalTransition();
        externalTransition(0, input);
    }

    @Override
    public Double getTimeAdvance() {
        return sigma;
    }

    @Override
    public MessageBag getOutput() {
        MessageBag output = new MessageBagImpl();

        if (phaseIs("InternalTransition")) {
            output.add(outProb, null);
        }
        return output;
    }

    // Custom function definitions

    //ID:CUST:0

    //<MM>
    public void setColumn(MarkovMat mm, int column, double[] col) {
        mm.getTransitionMatrix().setColumn(column, col);
    }

    public double[] getUnitVectorFor(MarkovMat mm, String state) {
        String[] s = mm.getStateNames();
        double[] allzeros = new double[s.length];
        for (int i = 0; i < s.length; i++) {
            if (s[i].equals(state)) {
                allzeros[i] = 1;
                return allzeros;
            }
        }
        return allzeros;
    }

    public void setInitialStateVector(MarkovMat mm, String state) {
        mm.setStateVector(getUnitVectorFor(mm, state));
    }

    public MarkovMat makeMarkovMat() {
        if (ctm == null) {
            ctm = new ContinuousTimeMarkov();
        }
        String path = getModelsDirectory().getAbsolutePath();
        path.replace("bin", "src");
        ctm.fillTransitionInfoList(path + File.separator + "xml" +
            File.separator + xmlFileName);
        com.ms4systems.devs.markov.TransitionInfo ti =
            ctm.getTransitionInfoFor("VerySick", "Sick");
        ti.setProbValue(PotencyOfTreatment);

        MarkovMat devs = new MarkovMat();
        devs.setStateVector(new double[ctm.getStates().size()]);
        devs.getStateVector()[0] = 1;
        devs.setLastStateVector(devs.getStateVector());
        devs.setTransitionMatrix(new Matrix(ctm.getStates().size()));
        ArrayList<String> states = ctm.indexStates();
        for (int i = 0; i < states.size(); i++) {
            devs.getTransitionMatrix().setColumn(i, ctm.getProbs(states.get(i)));
            devs.setStateName(i, states.get(i));
        }
        devs.getTransitionMatrix().print();
        return devs;
    }

    public void printStateVector(MarkovMat mm) {
        System.out.println();
        double sum = 0;
        for (int i = 0; i < mm.getStateVector().length; i++) {
            String nam = mm.getStateName(i);
            double p = mm.getStateVector()[i];
            sum += p;
            System.out.println(nam + " " + p);
        }
        System.out.println();
        System.out.println("CHECK " + getName() + sum);
    }

    public List<Dataset> getStatePlotDatasets(MarkovMat mm) {
        if (options.isDisablePlotting()) {
            return null;
        }
        ArrayList<Dataset> lst =
            new ArrayList<Dataset>(mm.getStateVector().length);
        {
            XYSeriesCollection dataset = new XYSeriesCollection();
            dataset.setGroup(new DatasetGroup("Probabilites"));
            series = new XYSeries[mm.getStateVector().length];
            double[] probs = mm.getStateVector();
            for (int i = 0; i < probs.length; i++) {
                series[i] = new XYSeries(mm.getStateName(i));
                dataset.addSeries(series[i]);
            }
            lst.add((Dataset) dataset);
        }
        return lst;
    }

    protected void updateStateVectorGraphValues() {
        if (options.isDisablePlotting()) {
            return;
        }
        getStatePlotDatasets(mm);
        Display.getDefault().asyncExec(new Runnable() {
                @Override
                public void run() {
                    double[] probs = mm.getStateVector();
                    for (int i = 0; i < probs.length; i++) {
                        series[i].add(getSimulator().getCurrentTime(),
                            (double) probs[i]);
                    }
                }
            });
    }

    public void internalTransitionForMatrix() {

        //mm.internalTransition();
        double[] x = mm.getStateVector();
        double[] y = new double[x.length];
        for (int i = 0; i < x.length; i++) {
            double yv = 0.;
            for (int j = 0; j < x.length; j++) {
                double[][] m = mm.getTransitionMatrix().getM();
                yv += m[i][j] * x[j];
            }
            y[i] = yv;
        }
        mm.setStateVector(y);
        maxima = ComputeOutputAtMax();
        printStateVector(mm);
        updateStateVectorGraphValues();
        mm.setCountOfTransitions(mm.getCountOfTransitions() + 1);
        if (mm.getEquilibriumState() &&
              mm.getCountOfTransitions() >= 10 * mm.getTransitionMatrix()
                                                     .getSize()) {
            passivate();
            System.out.println(getName() + " is conected from initial state " +
                mm.connectedFromInitialState());
            System.out.println(getName() + " most probable state: ");
            mm.printMostProbableState();
        }
        mm.setLastStateVector(mm.getStateVector());
        ProbOfHealthy = mm.getStateVector()[0];
        ProbOfSick = mm.getStateVector()[1];
        ProbOfVerySick = mm.getStateVector()[2];
    }

    public Double[] ComputeOutputAtMax() {
        double[] lastStateVector = mm.getLastStateVector();
        double[] newStateVector = mm.getStateVector();
        Double[] maxima = new Double[newStateVector.length];
        if (firstOutput.length == 0) {
            firstOutput = new boolean[maxima.length];
        }
        for (int i = 0; i < maxima.length; i++) {
            if (firstOutput[i]) {
                continue;
            }
            if (lastStateVector[i] > newStateVector[i] ||
                  (mm.getTransitionMatrix().getM()[i][i] == 1.0 &&
                  Math.abs(lastStateVector[i] - newStateVector[i]) < .01)) {
                if (lastStateVector[i] <= 0.) {
                    continue;
                }
                maxima[i] = lastStateVector[i];
                firstOutput[i] = true;
            }
        }
        return maxima;
    }

    public void ComputeIntermediate(String state) {
        double[] col = getUnitVectorFor(mm, state);
        int column = mm.getStateIndex(state);
        setColumn(mm, column, col);
    }

    public Double ComputeProbability(String finalState) {
        if (mm.getEquilibriumState() &&
              mm.getCountOfTransitions() >= 10 * mm.getTransitionMatrix()
                                                     .getSize() - 1) {
            double[] x = mm.getStateVector();
            int i = mm.getStateIndex(finalState);
            return x[i];
        }
        return null;
    }

    //<MM>

    //ENDID

    // End custom function definitions
    public static void main(String[] args) {
        SimulationOptionsImpl options = new SimulationOptionsImpl(args, true);

        // Uncomment the following line to disable SimViewer for this model
        // options.setDisableViewer(true);

        // Uncomment the following line to disable plotting for this model
        // options.setDisablePlotting(true);
        SickPatientNoDeathMM model = new SickPatientNoDeathMM();
        model.options = options;

        if (options.isDisableViewer()) { // Command line output only
            Simulation sim =
                new com.ms4systems.devs.core.simulation.impl.SimulationImpl("SickPatientNoDeathMM Simulation",
                    model, options);
            sim.startSimulation(0);
            sim.simulateIterations(Long.MAX_VALUE);
        } else { // Use SimViewer
            SimViewer viewer = new SimViewer();
            viewer.open(model, options);
        }
    }

    public void addPropertyChangeListener(String propertyName,
        PropertyChangeListener listener) {
        propertyChangeSupport.addPropertyChangeListener(propertyName, listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        propertyChangeSupport.removePropertyChangeListener(listener);
    }

    // Getter/setter for ctm
    public void setCtm(ContinuousTimeMarkov ctm) {
        propertyChangeSupport.firePropertyChange("ctm", this.ctm, this.ctm = ctm);
    }

    public ContinuousTimeMarkov getCtm() {
        return this.ctm;
    }

    // End getter/setter for ctm

    // Getter/setter for firstOutput
    public void setFirstOutput(boolean[] firstOutput) {
        propertyChangeSupport.firePropertyChange("firstOutput",
            this.firstOutput, this.firstOutput = firstOutput);
    }

    public boolean[] getFirstOutput() {
        return this.firstOutput;
    }

    // End getter/setter for firstOutput

    // Getter/setter for maxima
    public void setMaxima(Double[] maxima) {
        propertyChangeSupport.firePropertyChange("maxima", this.maxima,
            this.maxima = maxima);
    }

    public Double[] getMaxima() {
        return this.maxima;
    }

    // End getter/setter for maxima

    // Getter/setter for mm
    public void setMm(MarkovMat mm) {
        propertyChangeSupport.firePropertyChange("mm", this.mm, this.mm = mm);
    }

    public MarkovMat getMm() {
        return this.mm;
    }

    // End getter/setter for mm

    // Getter/setter for series
    public void setSeries(XYSeries[] series) {
        propertyChangeSupport.firePropertyChange("series", this.series,
            this.series = series);
    }

    public XYSeries[] getSeries() {
        return this.series;
    }

    // End getter/setter for series

    // Getter/setter for xmlFileName
    public void setXmlFileName(String xmlFileName) {
        propertyChangeSupport.firePropertyChange("xmlFileName",
            this.xmlFileName, this.xmlFileName = xmlFileName);
    }

    public String getXmlFileName() {
        return this.xmlFileName;
    }

    // End getter/setter for xmlFileName

    // Getter/setter for ProbOfHealthy
    public void setProbOfHealthy(double ProbOfHealthy) {
        propertyChangeSupport.firePropertyChange("ProbOfHealthy",
            this.ProbOfHealthy, this.ProbOfHealthy = ProbOfHealthy);
    }

    public double getProbOfHealthy() {
        return this.ProbOfHealthy;
    }

    // End getter/setter for ProbOfHealthy

    // Getter/setter for ProbOfSick
    public void setProbOfSick(double ProbOfSick) {
        propertyChangeSupport.firePropertyChange("ProbOfSick", this.ProbOfSick,
            this.ProbOfSick = ProbOfSick);
    }

    public double getProbOfSick() {
        return this.ProbOfSick;
    }

    // End getter/setter for ProbOfSick

    // Getter/setter for ProbOfVerySick
    public void setProbOfVerySick(double ProbOfVerySick) {
        propertyChangeSupport.firePropertyChange("ProbOfVerySick",
            this.ProbOfVerySick, this.ProbOfVerySick = ProbOfVerySick);
    }

    public double getProbOfVerySick() {
        return this.ProbOfVerySick;
    }

    // End getter/setter for ProbOfVerySick

    // Getter/setter for QualityOfHealth
    public void setQualityOfHealth(double QualityOfHealth) {
        propertyChangeSupport.firePropertyChange("QualityOfHealth",
            this.QualityOfHealth, this.QualityOfHealth = QualityOfHealth);
    }

    public double getQualityOfHealth() {
        return this.QualityOfHealth;
    }

    // End getter/setter for QualityOfHealth

    // Getter/setter for CostOfTreatment
    public void setCostOfTreatment(double CostOfTreatment) {
        propertyChangeSupport.firePropertyChange("CostOfTreatment",
            this.CostOfTreatment, this.CostOfTreatment = CostOfTreatment);
    }

    public double getCostOfTreatment() {
        return this.CostOfTreatment;
    }

    // End getter/setter for CostOfTreatment

    // Getter/setter for PotencyOfTreatment
    public void setPotencyOfTreatment(double PotencyOfTreatment) {
        propertyChangeSupport.firePropertyChange("PotencyOfTreatment",
            this.PotencyOfTreatment,
            this.PotencyOfTreatment = PotencyOfTreatment);
    }

    public double getPotencyOfTreatment() {
        return this.PotencyOfTreatment;
    }

    // End getter/setter for PotencyOfTreatment

    // Getter/setter for ValueOfTreatment
    public void setValueOfTreatment(double ValueOfTreatment) {
        propertyChangeSupport.firePropertyChange("ValueOfTreatment",
            this.ValueOfTreatment, this.ValueOfTreatment = ValueOfTreatment);
    }

    public double getValueOfTreatment() {
        return this.ValueOfTreatment;
    }

    // End getter/setter for ValueOfTreatment

    // State variables
    public String[] getStateVariableNames() {
        return new String[] {
            "ctm", "firstOutput", "maxima", "mm", "series", "xmlFileName",
            "ProbOfHealthy", "ProbOfSick", "ProbOfVerySick", "QualityOfHealth",
            "CostOfTreatment", "PotencyOfTreatment", "ValueOfTreatment"
        };
    }

    public Object[] getStateVariableValues() {
        return new Object[] {
            ctm, firstOutput, maxima, mm, series, xmlFileName, ProbOfHealthy,
            ProbOfSick, ProbOfVerySick, QualityOfHealth, CostOfTreatment,
            PotencyOfTreatment, ValueOfTreatment
        };
    }

    public Class<?>[] getStateVariableTypes() {
        return new Class<?>[] {
            ContinuousTimeMarkov.class, boolean[].class, Double[].class,
            MarkovMat.class, XYSeries[].class, String.class, Double.class,
            Double.class, Double.class, Double.class, Double.class, Double.class,
            Double.class
        };
    }

    public void setStateVariableValue(int index, Object value) {
        switch (index) {

            case ID_CTM:
                setCtm((ContinuousTimeMarkov) value);
                return;

            case ID_FIRSTOUTPUT:
                setFirstOutput((boolean[]) value);
                return;

            case ID_MAXIMA:
                setMaxima((Double[]) value);
                return;

            case ID_MM:
                setMm((MarkovMat) value);
                return;

            case ID_SERIES:
                setSeries((XYSeries[]) value);
                return;

            case ID_XMLFILENAME:
                setXmlFileName((String) value);
                return;

            case ID_PROBOFHEALTHY:
                setProbOfHealthy((Double) value);
                return;

            case ID_PROBOFSICK:
                setProbOfSick((Double) value);
                return;

            case ID_PROBOFVERYSICK:
                setProbOfVerySick((Double) value);
                return;

            case ID_QUALITYOFHEALTH:
                setQualityOfHealth((Double) value);
                return;

            case ID_COSTOFTREATMENT:
                setCostOfTreatment((Double) value);
                return;

            case ID_POTENCYOFTREATMENT:
                setPotencyOfTreatment((Double) value);
                return;

            case ID_VALUEOFTREATMENT:
                setValueOfTreatment((Double) value);
                return;

            default:
                return;
        }
    }

    // Convenience functions
    protected void passivate() {
        passivateIn("passive");
    }

    protected void passivateIn(String phase) {
        holdIn(phase, Double.POSITIVE_INFINITY);
    }

    protected void holdIn(String phase, Double sigma) {
        this.phase = phase;
        this.sigma = sigma;
        getSimulator()
            .modelMessage("Holding in phase " + phase + " for time " + sigma);
    }

    protected static File getModelsDirectory() {
        URI dirUri;
        File dir;
        try {
            dirUri = SickPatientNoDeathMM.class.getResource(".").toURI();
            dir = new File(dirUri);
        } catch (URISyntaxException e) {
            e.printStackTrace();
            throw new RuntimeException(
                "Could not find Models directory. Invalid model URL: " +
                SickPatientNoDeathMM.class.getResource(".").toString());
        }
        boolean foundModels = false;
        while (dir != null && dir.getParentFile() != null) {
            if (dir.getName().equalsIgnoreCase("java") &&
                  dir.getParentFile().getName().equalsIgnoreCase("models")) {
                return dir.getParentFile();
            }
            dir = dir.getParentFile();
        }
        throw new RuntimeException(
            "Could not find Models directory from model path: " +
            dirUri.toASCIIString());
    }

    protected static File getDataFile(String fileName) {
        return getDataFile(fileName, "txt");
    }

    protected static File getDataFile(String fileName, String directoryName) {
        File modelDir = getModelsDirectory();
        File dir = new File(modelDir, directoryName);
        if (dir == null) {
            throw new RuntimeException("Could not find '" + directoryName +
                "' directory from model path: " + modelDir.getAbsolutePath());
        }
        File dataFile = new File(dir, fileName);
        if (dataFile == null) {
            throw new RuntimeException("Could not find '" + fileName +
                "' file in directory: " + dir.getAbsolutePath());
        }
        return dataFile;
    }

    protected void msg(String msg) {
        getSimulator().modelMessage(msg);
    }

    // Phase display
    public boolean phaseIs(String phase) {
        return this.phase.equals(phase);
    }

    public String getPhase() {
        return phase;
    }

    public String[] getPhaseNames() {
        return new String[] { "InternalTransition", "Stop" };
    }

    // Graph support
    public List<Dataset> getPlotDatasets() {
        if (options.isDisablePlotting()) {
            return null;
        }
        ArrayList<Dataset> lst = new ArrayList<Dataset>(7);

        {
            XYSeriesCollection dataset = new XYSeriesCollection();
            dataset.setGroup(new DatasetGroup("Probabilites"));
            series0 = new XYSeries("ProbOfHealthy");
            dataset.addSeries(series0);
            series1 = new XYSeries("ProbOfSick");
            dataset.addSeries(series1);
            series2 = new XYSeries("ProbOfVerySick");
            dataset.addSeries(series2);
            series3 = new XYSeries("QualityOfHealth");
            dataset.addSeries(series3);
            lst.add((Dataset) dataset);
        }

        {
            XYSeriesCollection dataset = new XYSeriesCollection();
            dataset.setGroup(new DatasetGroup("CostAndPotency"));
            series4 = new XYSeries("CostOfTreatment");
            dataset.addSeries(series4);
            series5 = new XYSeries("PotencyOfTreatment");
            dataset.addSeries(series5);
            lst.add((Dataset) dataset);
        }

        {
            XYSeriesCollection dataset = new XYSeriesCollection();
            dataset.setGroup(new DatasetGroup("Effectiveness"));
            series6 = new XYSeries("ValueOfTreatment");
            dataset.addSeries(series6);
            lst.add((Dataset) dataset);
        }

        return lst;
    }

    // Graph update command
    protected void updateGraphValues() {
        if (options.isDisablePlotting()) {
            return;
        }
        Display.getDefault().asyncExec(new Runnable() {
                @Override
                public void run() {
                    series0.add(getSimulator().getCurrentTime(),
                        (double) ProbOfHealthy);
                    series1.add(getSimulator().getCurrentTime(),
                        (double) ProbOfSick);
                    series2.add(getSimulator().getCurrentTime(),
                        (double) ProbOfVerySick);
                    series3.add(getSimulator().getCurrentTime(),
                        (double) QualityOfHealth);
                    series4.add(getSimulator().getCurrentTime(),
                        (double) CostOfTreatment);
                    series5.add(getSimulator().getCurrentTime(),
                        (double) PotencyOfTreatment);
                    series6.add(getSimulator().getCurrentTime(),
                        (double) ValueOfTreatment);
                }
            });
    }
}
