package Models.java;
import com.ms4systems.devs.core.model.impl.CoupledModelImpl;
import com.ms4systems.devs.core.message.Port;
import com.ms4systems.devs.core.simulation.Simulation;
import com.ms4systems.devs.helpers.impl.SimulationOptionsImpl;
import com.ms4systems.devs.simviewer.standalone.SimViewer;
import java.io.Serializable;
import com.ms4systems.devs.extensions.StateVariableBased;
import com.ms4systems.devs.core.model.AtomicModel;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.TreeSet;

public class SickPatients extends CoupledModelImpl implements StateVariableBased{ 
	private static final long serialVersionUID = 1L;
	protected SimulationOptionsImpl options = new SimulationOptionsImpl();
	
	public SickPatients(){
		this("SickPatients");
	}
	public SickPatients(String nm) {
		super(nm);
		make();
	}
	public void make(){

		EFForTime EFForTime = new EFForTime();
		addChildModel(EFForTime);
		Susceptible_id1_SickPatientCTM Susceptible_id1_SickPatientCTM = new Susceptible_id1_SickPatientCTM();
		addChildModel(Susceptible_id1_SickPatientCTM);
		Susceptible_id4_SickPatientCTM Susceptible_id4_SickPatientCTM = new Susceptible_id4_SickPatientCTM();
		addChildModel(Susceptible_id4_SickPatientCTM);
		Immune_id2_SickPatientCTM Immune_id2_SickPatientCTM = new Immune_id2_SickPatientCTM();
		addChildModel(Immune_id2_SickPatientCTM);
		Immune_id0_SickPatientCTM Immune_id0_SickPatientCTM = new Immune_id0_SickPatientCTM();
		addChildModel(Immune_id0_SickPatientCTM);
		Immune_id3_SickPatientCTM Immune_id3_SickPatientCTM = new Immune_id3_SickPatientCTM();
		addChildModel(Immune_id3_SickPatientCTM);
		addCoupling(Immune_id3_SickPatientCTM.outVerySickTime,EFForTime.inVerySickTime);
		addCoupling(Susceptible_id4_SickPatientCTM.outVerySickTime,EFForTime.inVerySickTime);
		addCoupling(Immune_id0_SickPatientCTM.outVerySickTime,EFForTime.inVerySickTime);
		addCoupling(Susceptible_id1_SickPatientCTM.outVerySickTime,EFForTime.inVerySickTime);
		addCoupling(Immune_id2_SickPatientCTM.outVerySickTime,EFForTime.inVerySickTime);
		addCoupling(Immune_id3_SickPatientCTM.outLifeTime,EFForTime.inLifeTime);
		addCoupling(Susceptible_id4_SickPatientCTM.outLifeTime,EFForTime.inLifeTime);
		addCoupling(Immune_id0_SickPatientCTM.outLifeTime,EFForTime.inLifeTime);
		addCoupling(Susceptible_id1_SickPatientCTM.outLifeTime,EFForTime.inLifeTime);
		addCoupling(Immune_id2_SickPatientCTM.outLifeTime,EFForTime.inLifeTime);

	}
    @Override
    public String[] getStateVariableNames() {
        ArrayList<String> lst = new ArrayList<String>();
        for (AtomicModel child : getChildren())
            if (child instanceof StateVariableBased)
                for (String childVar : ((StateVariableBased) child)
                        .getStateVariableNames())
                    lst.add(child.getName() + "." + childVar);
        return lst.toArray(new String[0]);
    }

    @Override
    public Object[] getStateVariableValues() {
        ArrayList<Object> lst = new ArrayList<Object>();
        for (AtomicModel child : getChildren())
            if (child instanceof StateVariableBased)
                for (Object childVar : ((StateVariableBased) child)
                        .getStateVariableValues())
                    lst.add(childVar);
        return lst.toArray();
    }

    @Override
    public Class<?>[] getStateVariableTypes() {
        ArrayList<Class<?>> lst = new ArrayList<Class<?>>();
        for (AtomicModel child : getChildren())
            if (child instanceof StateVariableBased)
                for (Class<?> childVar : ((StateVariableBased) child)
                        .getStateVariableTypes())
                    lst.add(childVar);
        return lst.toArray(new Class<?>[0]);
    }

    @Override
    public void setStateVariableValue(int index, Object value) {
        int i = 0;
        for (AtomicModel child : getChildren())
            if (child instanceof StateVariableBased)
                for (int childIndex = 0; childIndex < ((StateVariableBased) child)
                        .getStateVariableNames().length; childIndex++) {
                    if (i == index) {
                        ((StateVariableBased) child).setStateVariableValue(
                                childIndex, value);
                        return;
                    }
                    i++;
                }
    }
    
	public static void main(String[] args){
		SimulationOptionsImpl options = new SimulationOptionsImpl(args, true);
		// Uncomment the following line to disable SimViewer for this model
		// options.setDisableViewer(true);
		// Uncomment the following line to disable plotting for this model
		// options.setDisablePlotting(true);

		SickPatients model = new SickPatients();
		model.options = options;
		if(options.isDisableViewer()){ // Command Line output only
			Simulation sim = new com.ms4systems.devs.core.simulation.impl.SimulationImpl("SickPatients Simulation",model,options);
			sim.startSimulation(0);
			sim.simulateIterations(Long.MAX_VALUE);
		}else { //Use SimViewer
			SimViewer viewer = new SimViewer();
			viewer.open(model,options);
		}
	}
}